/**********************************************************
*                                                         *
* (c) 2008 - 2013 LnK                                     *
*                                                         *
* LnKSLIMbusAnalyzer_TG_IF.h                              *
* Version 1.6                                             *
*                                                         *
* Header file for LnKSLIMbusAnalyzer_TG_IF DLL            *
*                                                         *
* Date 17 January 2013                                    *
*                                                         *
* Johan Klewais                                           *
*                                                         *
* www.lnk-tools.com - info@lnk-tools.com                  *
*                                                         *
**********************************************************/

typedef struct
  {
	unsigned long	Version;						// 1
	unsigned long	Len;							// sizeof(DATA_REPORT_HDR)

	unsigned long	idx;							// index in the global data history file
	unsigned long	ch;								// data channel number
	unsigned long	sf;								// super frame number

	unsigned long	Timestamp_ms;					// time stamp   s, ms
	unsigned long	Timestamp_ns;					// time stamp   us, ns

	unsigned long	RootFreq;						// Root Frequency
	unsigned long	ClockGear;						// Clock Gear

	bool			Inited;							// true when this channel has been initialized
	bool			Enabled;						// true when this channel has been activated
	unsigned char	Protocol;						// Data transport Protocol used

	unsigned long	Offset;							// Offset position of the first data slot
	unsigned long	Length;							// length of the data sample in slots
	unsigned long	Interval;						// interval size between the data samples in slots
	unsigned long	SegDist;

	unsigned char	FreqLock;						// Frequency Lock Bit
	unsigned long	PresenceRate;					// Presence Rate
	unsigned char	AuxBitFormat;					// Aux Bit Format
	unsigned char	DataType;						// Data Type
	unsigned char	ChannelLink;					// Channel Link bit
	unsigned char	DataLength;						// Data length (number of slots used of data in the complete sample)
	unsigned char	TagLen;							// number of TAG slots used in the data sample

	double			MeasuredPresenceRate;			// measured presence rate
	
  } DATA_REPORT_HDR;  



extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusOpen(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusClose(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetSWVersion(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetDLLVersion(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetConfig(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetSN(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetHWid(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusAnalyzerStartRecordFull(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusAnalyzerStopRecordFull(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusAnalyzerStartRecordMessages(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusAnalyzerStopRecordMessages(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusAnalyzerPollLiveViewMessageCounter(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusAnalyzerGetLiveViewMessage(char * message);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusSaveAsSBA(char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusOpenSBA( char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusImportVcd( char * filename, char * datalabel, char * clocklabel );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusExportRaw( int Format, int From, int To, bool All, bool IncludeFrameInfo, char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusExportData( int Channel, int Format, int From, int To, bool All, char * filename , bool DataMode );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusExportMsg( int Type, int Format, int From, int To, bool All, bool IncludeFrameInfo, int LogicalAddress, char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusTrafficGeneratorLoadTG( char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusTrafficGeneratorLoadXML( char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusTrafficGeneratorPlay(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusTrafficGeneratorStop(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusHWSetConfig( unsigned char SBLevel, unsigned char IOLevel, bool BusHold);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusHWGetConfig(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusHWIsConnected(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetActionStatus(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetSLIMBusStatus(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusHWReset(void);
//1.6
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusReportAllActiveDataChannels( unsigned char * ActiveDataChannels);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetDataChannelHistory( int channel );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetAllDataChannelsHistory( void );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusRetrieveDataChannelHistory( DATA_REPORT_HDR * drh);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetDataChannelHistory2CSV( int channel, char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetAllDataChannelsHistory2CSV( char * filename );



// Return values defines

#define	LNK_SLIMBUS_OK						0
#define LNK_SLIMBUS_ANALYZER_NOT_FOUND		(-1)
#define LNK_SLIMBUS_ACTION_NOT_ALLOWED		(-2)
#define LNK_SLIMBUS_FILE_WRITE_ERROR		(-3)
#define LNK_SLIMBUS_FILE_READ_ERROR			(-4)
#define LNK_SLIMBUS_FORMAT_TYPE_ERROR		(-5)
#define LNK_SLIMBUS_XML_TRANSLATION_ERROR	(-6)
#define LNK_SLIMBUS_HARDWARE_NOT_CONNECTED	(-7)
#define LNK_SLIMBUS_COMMAND_BUSY			(-8)
#define LNK_SLIMBUS_INVALID_VALUE			(-9)
#define LNK_SLIMBUS_NO_BUS_ACTIVITY_SEEN	(-10)
#define LNK_SLIMBUS_ERROR_LAST				(-11)
#define LNK_SLIMBUS_EMPTY					(-12)

// License configuration codes 
#define LNK_SLIMBUS_CONFIG_SLIMBUS			0x01
#define LNK_SLIMBUS_CONFIG_SW_ANALYZER		0x02
#define LNK_SLIMBUS_CONFIG_SW_TG			0x04
#define LNK_SLIMBUS_CONFIG_HW_ANALYZER		0x08
#define LNK_SLIMBUS_CONFIG_HW_TG			0x10


// Hardware ID defines
#define LNK_SLIMBUS_IF_VERSION_1			0x01
#define LNK_SLIMBUS_IF_VERSION_2			0x02
#define LNK_SLIMBUS_IF_VERSION_3			0x03		

// Export Format defines
#define LNK_SLIMBUS_EXPORT_FORMAT_TXT		0
#define LNK_SLIMBUS_EXPORT_FORMAT_HTML		1
#define LNK_SLIMBUS_EXPORT_FORMAT_WAV		2


// Export Message Type defines
#define LNK_SLIMBUS_EXPORT_MSG_TYPE_RAW				0
#define LNK_SLIMBUS_EXPORT_MSG_TYPE_DETAILED		1
#define LNK_SLIMBUS_EXPORT_MSG_TYPE_SYNTHETIC		2


// Get Status defines
#define LNK_SLIMBUS_IDLE							0
#define LNK_SLIMBUS_FULL_RECORDING					1
#define LNK_SLIMBUS_MESSAGE_RECORDING				2


// int _stdcall LnKSLIMbusOpen(void);
//
// This function opens the interface to the SLIMbus Analyzer Traffic generator
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//


// int _stdcall LnKSLIMbusClose(void);
//
// This function closes the interface to the SLIMbus Analyzer Traffic generator
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//


// int _stdcall LnKSLIMbusGetSWVersion(void);
//
// This function requests the version number of the software of the SLIMbus Analyzer Traffic generator
//
// Input parameters: 
//						- none
//
// Return value: 
//						- version  (in decimal ex. 153 means 1.53) 
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusGetDLLVersion(void);
//
// This function requests the version number of this DLL of the SLIMbus Analyzer Traffic generator interface
//
// Input parameters: 
//						- none
//
// Return value: 
//						- version  (in decimal ex. 100 means 1.00) 
//						
//


// int _stdcall LnKSLIMbusGetConfig(void);
//
// This function returns the configuration of the SLIMbus Analyzer Traffic generator
// The configuration indicates the functions that are allowed by the license agreement
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_CONFIG_SW_ANALYZER
//						- LNK_SLIMBUS_CONFIG_SW_TG
//						- LNK_SLIMBUS_CONFIG_HW_ANALYZER
//						- LNK_SLIMBUS_CONFIG_HW_TG
//						- LNK_SLIMBUS_COMMAND_BUSY
//						
//


// int _stdcall LnKSLIMbusGetSN(void);
//
// This function returns the serial number of the SLIMbus Analyzer Traffic generator License Key
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_COMMAND_BUSY
//						- License key serial number
//

// int _stdcall LnKSLIMbusGetHWid(void);
//
// This function returns the serial number of the SLIMbus Analyzer Traffic generator License Key
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY
//						- LNK_SLIMBUS_IF_VERSION_1
//						- LNK_SLIMBUS_IF_VERSION_2
//						- LNK_SLIMBUS_IF_VERSION_3
//

// int _stdcall LnKSLIMbusAnalyzerStartRecordFull(void);
//
// This function starts a FULL RECORD of the SLIMbus Analyzer 
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the analyzer is already recording)
//



// int _stdcall LnKSLIMbusAnalyzerStopRecordFull(void);
//
// This function stops a FULL RECORD of the SLIMbus Analyzer 
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the analyzer is not recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//




// int _stdcall LnKSLIMbusAnalyzerStartRecordMessages(void);
//
// This function starts a MESSAGE RECORD of the SLIMbus Analyzer 
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the analyzer is already recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//

// int _stdcall LnKSLIMbusAnalyzerStopRecordMessages(void);
//
// This function stops a MESSAGE RECORD of the SLIMbus Analyzer 
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the analyzer is not recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusAnalyzerPollLiveViewMessageCounter(void);
//
// This function returns the number of captured messages that are available in the analyzer buffer for transfer
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY
//						- a number >= 0  represents the number of messages available in the message buffer
//


// int _stdcall LnKSLIMbusAnalyzerGetLiveViewMessage(char * message);
//
// This function gets the next captured (Live View/ message record) message out of the analyzer buffer.
// 
//
// Input parameters: 
//						- char * message
//							the raw message will be copied into the buffer pointed by this pointer
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusSaveAsSBA(char * filename );
//
// This function saves the current trace of the analyzer into an '*.sba' file
//
// Input parameters: 
//						- char * filename
//							This filename will be used to save the currect trace as an sba file 
//
// Return value: 
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_FILE_WRITE_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the analyzer is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//

// int _stdcall LnKSLIMbusOpenSBA( char * filename );
//
// This function opens an '*.sba' file and load in into the analyzer tool 
//
// Input parameters: 
//						- char * filename
//							This filename will be used to open an sba file and load into the tool
//
// Return value: 
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_FILE_READ_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the analyzer is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusImportVcd( char * filename, char * datalabel, char * clocklabel );
//
// This function imports a 'VCD' file and converts it according to the SLIMBUS Data and SLIMBIUS Clock signals found in the file.
// The translated trace will be loaded into the analyzer tool 
//
// Input parameters: 
//						- char * filename
//							This filename will be used to open a VCD file and import in into the tool
//
//						- char * datalabel
//							This is the label name of the SLIMBUS DATA signal used in the VCD trace
//
//						- char * clocklabel
//							This is the label name of the SLIMBUS CLOCK signal used in the VCD trace
//
// Return value: 
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_FILE_READ_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the analyzer is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusExportRaw( int Format, int From, int To, bool All, bool IncludeFrameInfo, char * filename );
//
// This function exports the currect trace in the tool and converts the RAW SLIMBUS data to the selected format into a file..
//
// Input parameters: 
//						- int Format 
//							This is the start SuperFrame number 
//							- LNK_SLIMBUS_EXPORT_FORMAT_TXT		
//							- LNK_SLIMBUS_EXPORT_FORMAT_HTML		
//
//						- int From 
//							This is the start SuperFrame number 
//
//						- int To 
//							This is the end SuperFrame number to be included in the export
//
//						- bool All 
//							If "All" is true then the complete trace will be exported 
//
//						- bool IncludeFrameInfo
//							When IncludeFrameInfo is true, als the framing info will be included in the export
//
//						- char * filename
//							This filename will be used to open and write the export file
//
// Return value: 
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_FILE_WRITE_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the analyzer is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusExportData( int Channel, int Format, int From, int To, bool All, char * filename , bool DataMode );
//
// This function exports the data of the current trace in the tool and converts it into the selected format to a file..
//
// Input parameters: 
//						- int Channel 
//							This indicates the data channel that has to be exported 
//
//						- int Format 
//							This parameter defines the format. Text or html output.
//							- LNK_SLIMBUS_EXPORT_FORMAT_TXT		
//							- LNK_SLIMBUS_EXPORT_FORMAT_HTML		
//
//
//						- int From 
//							This is the start SuperFrame number 
//
//						- int To 
//							This is the end SuperFrame number to be included in the export
//
//						- bool All 
//							If "All" is true then the complete trace will be exported 
//
//						- bool IncludeFrameInfo
//							When IncludeFrameInfo is true, als the framing info will be included in the export
//
//						- char * filename
//							This filename will be used to open and write the export file
//
// Return value: 
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_FILE_WRITE_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the analyzer is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusExportMsg( int Type, int Format, int From, int To, bool All, bool IncludeFrameInfo, char * filename );
///
// This function exports the message channel of the currect trace in the tool and converts it into the selected format to a file..
//
// Input parameters: 
//						- int Type 
//							This is the start SuperFrame number 
//							- LNK_SLIMBUS_EXPORT_MSG_TYPE_RAW			
//							- LNK_SLIMBUS_EXPORT_MSG_TYPE_DETAILED		
//							- LNK_SLIMBUS_EXPORT_MSG_TYPE_SYNTHETIC		
//
//						- int Format 
//							This parameter defines the format. Text or html output.
//							- LNK_SLIMBUS_EXPORT_FORMAT_TXT		
//							- LNK_SLIMBUS_EXPORT_FORMAT_HTML		
//
//						- int From 
//							This is the start message number 
//
//						- int To 
//							This is the end message number to be included in the export
//
//						- bool All 
//							If "All" is true then the complete trace will be exported 
//
//						- bool IncludeFrameInfo
//							When IncludeFrameInfo is true, als the framing info will be included in the export
//
//						- char * filename
//							This filename will be used to open and write the export file
//
// Return value: 
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_FILE_WRITE_ERROR
//						- LNK_SLIMBUS_FORMAT_TYPE_ERROR (this type is not available with this format)
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the analyzer is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusTrafficGeneratorLoadTG( char * filename );
//
// This function loads a 'tg' file (binary traffic generator file) into the traffic generator memory.
// An XML file will be translated into visual content in the tool and is shown in the same way as a captured trace.
//
// Input parameters: 
//						- char * filename
//							This filename will be used to open an 'xml' file.
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_FILE_READ_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the analyzer is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusTrafficGeneratorLoadXML( char * filename );
//
// This function loads a 'XML' script file into the analyzer platform and into the traffic generator memory.
// A TG file will not be translated into visual content in the tool and is mainly used for automatic
// loading of "pre translated" scripts. This saves time of preprocessing the original XML scripts every time.
//
// Input parameters: 
//						- char * filename
//							This filename will be used to open an 'tg' file (binary traffic generator file) and load in into the traffic generator memory
//
// Return value: 
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_XML_TRANSLATION_ERROR
//						- LNK_SLIMBUS_FILE_READ_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the analyzer is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//

// int _stdcall LnKSLIMbusTrafficGeneratorPlay(void);
//
// This function starts the Traffic Generator streaming out the pre loaded SLIMBUS pattern
//
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY
//

// int _stdcall LnKSLIMbusTrafficGeneratorStop(void);
//
// This function stops the Traffic Generator from streaming out the pre loaded SLIMBUS pattern
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusHWSetConfig( unsigned char SBLevel, unsigned char IOLevel, bool BusHold);
//
// This function sets the parameters of the real SLIMBUS signals of the hardware capture unit
//
// Input parameters: 
//						- unsigned char SBLevel
//							SLIMBUS Data and Clock line voltage levels: 12 = 1v2, 18=1v8, 33=3v3
//
//						- unsigned char IOLevel
//							Trigger In/Out voltage levels: 12 = 1v2, 18=1v8, 33=3v3
//
//						- bool BusHold
//							SLIMBUS Data Bus Hold, 1 = active, 0 = inactive
//
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusHWGetConfig(void);
//
// This function gets the parameters of the real SLIMBUS signals of the hardware capture unit
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY
//						if > 0
//						- bits 0-7  SLIMBUS Data and Clock line voltage level: 12=1v2, 18=1v8, 33=3v3
//						- bits 8-15 Trigger I/O Voltage level: 12=1v2, 18=1v8, 33=3v3
//						- bit 16	SLIMBUS Data Bus Hold, 1 = active, 0 = inactive
//



// int _stdcall LnKSLIMbusHWIsConnected(void);
//
// This function returns if the hardware unit is connected and functional
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusGetActionStatus(void);
//
// This function returns the currect action of the tool
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_IDLE
//						- LNK_SLIMBUS_FULL_RECORDING
//						- LNK_SLIMBUS_MESSAGE_RECORDING
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusGetSLIMBusStatus(void);
//
// This function returns the currect action of the tool
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY
//						if > 0
//						- bits 0 - 3		RootFreq		4 bits
//						- bits 4 - 7		ClockGear		4 bits
//						- bits 8 - 12		SubFrameMode	5 bits
//						- bit  16			Current Clock activity on the bus	
//						- bit  17			Current Data activity on the bus	
//						- bit  18			Current Frame Sync state on the bus	
//						- bit  19			Current Super Frame Sync state on the bus	
//
//


// int _stdcall LnKSLIMbusHWReset( void );
//
// This function resets the hardware unit if it is connected
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_ANALYZER_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//

// int _stdcall LnKSLIMbusReportAllActiveDataChannels( unsigned char * ActiveDataChannels);
//
// This function returns an array with all active data channels detected in the current stream
//
// Input parameters: 
//						- pointer to an array of 256 chars (bytes) to hold all possible active data channels
//
// Return value:		>= 0 = number of active data channels detected in the current trace
//						- LNK_SLIMBUS_OK
//
//						the input array is filled with a list of active data channels in numeric order 
//							ex. 1,4,5,0,0,0,0,0,0,0,0,0,0,0 .....
//


// int _stdcall LnKSLIMbusGetDataChannelHistory( int channel );
//
// This function returns the number of data channel changes for a requested channel and
// fills the structure that contains all details of these changes.
// To retrieve this content, use LnKSLIMbusRetrieveDataChannelHistory( DATA_REPORT_HDR * drh)
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//


// int _stdcall LnKSLIMbusGetAllDataChannelsHistory( void );
//
// This function returns the number of data channel changes for all active data channels and 
// fills the structure that contains all details of these changes.
// To retrieve this content, use LnKSLIMbusRetrieveDataChannelHistory( DATA_REPORT_HDR * drh)
//
// Input parameters: 
//						- none
//
// Return value:		>= 0  returns the number of changes
//						- LNK_SLIMBUS_OK
//


// int _stdcall LnKSLIMbusRetrieveDataChannelHistory( DATA_REPORT_HDR * drh);
//
// This function retrieves the data channel changes for the last request 
// before calling this function, the LnKSLIMbusGetDataChannelHistory(int channel) or 
// LnKSLIMbusGetAllDataChannelsHistory()
//
//
// Input parameters: 
//						- DATA_REPORT_HDR * drh  (pointer to the structure to hold a data report)
//
// Return value: 
//						- LNK_SLIMBUS_OK				a valid header has been provided
//						- LNK_SLIMBUS_EMPTY				no more headers have been provided
//						- LNK_SLIMBUS_FILE_READ_ERROR	
//


// int _stdcall LnKSLIMbusGetDataChannelHistory2CSV( int channel, char * filename );
//
// This function exports all data channel changes for a requested channel into a CSV file
//
// Input parameters: 
//						- int channel		the number of the requested data channel
//						- char * filename
//							This filename will be used to create a 'csv' file  that contains data channel changes
// Return value: 
//						- LNK_SLIMBUS_OK
//

// int _stdcall LnKSLIMbusGetAllDataChannelsHistory2CSV( char * filename )
//
// This function exports all data channel changes for all channels into a CSV file
//
// Input parameters: 
//						- char * filename
//							This filename will be used to create a 'csv' file  that contains data channel changes
// Return value: 
//						- LNK_SLIMBUS_OK
//

